/**********************************************************************
*       Author   : Gabriele Zannoni
*       Created  : 11/6/2007 - 9:47
*       Modified : 11/6/2007 - 9:47
*
*       Description :
*         Prova 5 - 2007
***********************************************************************/


#include <stdio.h>

#include "configuration.h"
#include "plateTime.h"
#include "plateVelocity.h"
#include "tests.h"

int main(void)
{
    int i;
    FILE *fout = stdout;

    test_stringToTime();
    test_timeDifference();

    test_addPlateTime();
    test_concatPlateTimeLists();
    test_getPlateTimeListLength();
    test_findPlateTime();

    //fout = fopen("result.txt", "w");

    for (i = 0; i < GATE_PAIR_ARRAY_LENGTH; i++)
    {
        PlateTimeList firstGatePlateTimeList, secondGatePlateTimeList;
        PlateVelocityPtr plateVelocities;
        int plateVelocitiesDim;

        firstGatePlateTimeList = readGateFiles(GatePairArray[i].firstGateName);
        secondGatePlateTimeList = readGateFiles(GatePairArray[i].secondGateName);

        plateVelocitiesDim = calculateVelocities(GatePairArray[i], 
            firstGatePlateTimeList, secondGatePlateTimeList, &plateVelocities);

        printVelocities(fout, GatePairArray[i], plateVelocities, plateVelocitiesDim);

        destroyPlateTimeList(firstGatePlateTimeList);
        destroyPlateTimeList(secondGatePlateTimeList);
        destroyVelocities(plateVelocities);
    }

    //fclose(fout);
	return (0);
}


