#include <stdio.h>
#include "time.h"
#include "gatePair.h"

#ifndef PLATE_TIME
#define PLATE_TIME

#define PLATE_DIM 20
typedef char Plate[PLATE_DIM];

typedef struct
{
    Plate plate;
    Time time;
} PlateTime;

typedef struct PlateTimeListStruct
{
    PlateTime data;
    struct PlateTimeListStruct *next;
} PlateTimeElement;

typedef PlateTimeElement *PlateTimeList;

#endif

PlateTimeList addPlateTime(PlateTimeList list, PlateTime data);
PlateTimeList concatPlateTimeLists(PlateTimeList head, PlateTimeList tail);
int getPlateTimeListLength(PlateTimeList list);
PlateTime* findPlateTime(PlateTimeList list, Plate plate);
void destroyPlateTimeList(PlateTimeList list);

PlateTimeList readPlateTimeFile(FILE *f);
PlateTimeList readGateFiles(GateName name);