#include <stdlib.h>
#include <string.h>
#include "plateVelocity.h"

int calculateVelocities(GatePair gatePair, PlateTimeList firstGateList, PlateTimeList secondGateList, PlateVelocityPtr *plateVelocities)
{
    int firstGateListLength, secondGateListLength, maxResultLength, resultIndex;
    firstGateListLength = getPlateTimeListLength(firstGateList);
    secondGateListLength = getPlateTimeListLength(secondGateList);
    maxResultLength = firstGateListLength > secondGateListLength ? firstGateListLength : secondGateListLength;
    *plateVelocities = (PlateVelocityPtr)malloc(sizeof(PlateVelocity) * maxResultLength);

    resultIndex = 0;
    while (firstGateList != NULL)
    {
        PlateTime firstGatePlateTime = firstGateList->data;
        PlateTime *secondGatePlateTime = findPlateTime(secondGateList, firstGatePlateTime.plate);
        if (secondGatePlateTime != NULL)
        {
            float timeDiff = timeDifference(secondGatePlateTime->time, firstGatePlateTime.time);
            strcpy((*plateVelocities)[resultIndex].plate, firstGatePlateTime.plate);
            (*plateVelocities)[resultIndex].velocity = gatePair.distance / timeDiff;
            resultIndex++;
        }
        firstGateList = firstGateList->next;
    }
    return resultIndex;
}

void printVelocities(FILE *fout, GatePair gatePair, PlateVelocityPtr plateVelocities, int dim)
{
    int i;
    fprintf(fout, "%s --> %s; distance: %f\n", gatePair.firstGateName, gatePair.secondGateName, gatePair.distance);
    for (i = 0; i < dim; i++)
    {
        fprintf(fout, "%s; v = %fKm/h\n", plateVelocities[i].plate, plateVelocities[i].velocity);
    }
    fprintf(fout, "\n");
}

void destroyVelocities(PlateVelocityPtr plateVelocities)
{
    free(plateVelocities);
}