#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include "tests.h"
#include "time.h"
#include "plateTime.h"
#include "plateVelocity.h"

//time
void test_stringToTime()
{
    Time time;
    char timeString[] = "10:22:11";

    time = stringToTime(timeString);
    assert(time.hour == 10 && time.minute == 22 && time.second == 11);
}

void test_timeDifference()
{
    char ts1[] = "10:40:36";
    char ts2[] = "09:10:00";

    char ts3[] = "00:30:00";
    char ts4[] = "23:30:00";

    float td1, td2;
    td1 = timeDifference(stringToTime(ts1), stringToTime(ts2));
    td2 = timeDifference(stringToTime(ts3), stringToTime(ts4));
    assert(td1 > 1.509F && td1 < 1.511F);
    assert(td2 > 0.99F && td2 < 1.01F);
}

PlateTimeElement _plateTimeElement1, _plateTimeElement2;
int init = 0;

PlateTimeList getTestList()
{
    strcpy(_plateTimeElement1.data.plate, "Plate1");
    _plateTimeElement1.data.time.hour = 10;
    _plateTimeElement1.data.time.minute = 10;
    _plateTimeElement1.data.time.second = 10;
    strcpy(_plateTimeElement2.data.plate, "Plate2");
    _plateTimeElement2.data.time.hour = 11;
    _plateTimeElement2.data.time.minute = 11;
    _plateTimeElement2.data.time.second = 11;
    _plateTimeElement1.next = &_plateTimeElement2;
    _plateTimeElement2.next = NULL;
    return &_plateTimeElement1;
}

//plateTime
void test_addPlateTime()
{
    PlateTimeList list;
    PlateTime plateToAdd;
    strcpy(plateToAdd.plate, "Plate3");
    list = addPlateTime(getTestList(), plateToAdd);
    assert(strcmp(list->data.plate, "Plate3") == 0 || strcmp(list->next->data.plate, "Plate3") == 0 ||
        strcmp(list->next->next->data.plate, "Plate3") == 0);
    free(list);
}

void test_concatPlateTimeLists()
{
    PlateTimeElement e;
    PlateTimeList list = &e;

    strcpy(e.data.plate, "Plate3");
    e.next = NULL;

    list = concatPlateTimeLists(list, getTestList());
    assert(strcmp(list->data.plate, "Plate3") == 0 || strcmp(list->next->data.plate, "Plate3") == 0 ||
        strcmp(list->next->next->data.plate, "Plate3") == 0);
}

void test_getPlateTimeListLength()
{
    assert(getPlateTimeListLength(getTestList()) == 2);
}

void test_findPlateTime()
{
    PlateTime *foundPlate;
    foundPlate =  findPlateTime(getTestList(), "Plate2");
    assert(foundPlate != NULL);
    assert(foundPlate->time.hour == 11 && foundPlate->time.minute == 11 && foundPlate->time.second == 11);

    foundPlate = findPlateTime(getTestList(), "No");
    assert(foundPlate == NULL);
}
